<TeXmacs|1.0.7.20>

<style|<tuple|beamer|mathemagix|tmdoc-markup|tmdoc-keyboard|maxima|vdh>>

<\body>
  <\hide-preamble>
    <assign|num|<macro|x|<anim-constant|<tabular*|<tformat|<cwith|1|1|1|1|cell-lsep|5mm>|<cwith|1|1|1|1|cell-rsep|5mm>|<cwith|1|1|1|1|cell-bsep|5mm>|<cwith|1|1|1|1|cell-tsep|5mm>|<table|<row|<cell|<arg|x>>>>>>|2sec>>>
  </hide-preamble>

  <screens|<\shown>
    \;

    <\with|par-mode|center>
      <strong|<\with|font-base-size|17>
        Ball arithmetic
      </with>>

      <action|<abbr|Joris> van der Hoeven|(system "qtplay Sanglier.m4a &")>

      <small|CNRS, cole polytechnique>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<with|magnification|15|<tiny-switch|<shown|<anim-compose|<tabular*|<tformat|<table|<row|<cell|<anim-constant|7|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|6|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|5|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|4|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|3|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|2|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|1|2sec>>>>>>|<tabular*|<tformat|<table|<row|<cell|<anim-constant|0|2sec>>>>>>>>|<hidden|<anim-repeat|<anim-compose|<anim-constant|<space|0.2spc>/<phantom|\\>|1sec>|<anim-constant|<space|0.2spc><phantom|/>\\|1sec>>>>>>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<strong|Luminy,
      2010<rsub|<math|<rsub|>>>>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<TeXmacs*>.jp>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Objectives>

    \;

    <unroll|<\shown>
      <unroll|<\shown>
        <strong|Long term program:>

        <\itemize>
          <item>Understand the practical complexity of computable analysis.

          <item>Design fast algorithms for common analytic computations.

          <item><name|Mathemagix>: a free ``computer analysis'' system.

          <item>Make computable analysis ``competitive'' with numerical
          analysis.
        </itemize>
      </shown>>
    </shown>|<\hidden*>
      \;

      <unroll|<\shown>
        <strong|Existing software:>

        <\itemize>
          <item>Computable real numbers. <greyed|Mostly restricted to
          numbers>

          <item>Interval arithmetic. <greyed|Mostly double precision>

          <item>Fast arithmetic. <greyed|Applications mostly algebraic or
          discrete>

          <item>Other libraries. <greyed|Mostly specialized, <abbr|e.g.> find
          roots of <math|P\<in\>\<bbb-C\>[z]>>
        </itemize>
      </shown>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|The numerical hierarchy>

    <unroll|<\shown>
      <strong|Mathematical level>

      <switch|<\shown>
        <math|x\<in\>\<bbb-R\><rsup|com>>
        <math|<with|color|black|\<leftrightsquigarrow\>>>
        <math|\<exists\><wide|x|\<check\>>:\<varepsilon\>\<in\>\<bbb-Q\><rsup|\<gtr\>>\<rightarrowlim\><rsup|comp><wide|x|~>\<in\>\<bbb-Q\>>,
        <math|\|<wide|x|~>-x\|\<leqslant\>\<varepsilon\>>
      </shown>|<\hidden>
        <math|x\<in\>\<bbb-R\><rsup|com>>
        <math|<with|color|black|\<leftrightsquigarrow\>>>
        <math|\<exists\><wide|x|\<check\>>:\<varepsilon\>\<in\>\<bbb-D\><rsup|\<gtr\>>\<longmapstolim\><rsup|comp><wide|x|~>\<in\>\<bbb-D\>>,
        <math|\|<wide|x|~>-x\|\<leqslant\>\<varepsilon\>><htab|5mm>(<math|\<bbb-D\>=\<bbb-Z\>*2<rsup|\<bbb-Z\>>>)<vspace|0.5fn>
      </hidden>>
    </shown>|<\hidden*>
      <strong|Reliable level>

      <switch|<\shown>
        <math|x<rsup|\<leftrightmap\>>=[x<rsub|l>,x<rsub|r>]\<in\>\<cal-I\>(\<bbb-D\>)>
      </shown>|<\hidden>
        <math|x<rsup|\<circ\>>={<wide|x|~>\<in\>\<bbb-R\>:\|<wide|x|~>-x<rsub|c>\|\<leqslant\>x<rsub|r>}\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)>
      </hidden>|<\hidden>
        <math|x<rsup|\<circ\>>={<wide|x|~>\<in\>\<bbb-R\>:\|<wide|x|~>-x<rsub|c>\|\<leqslant\>x<rsub|r>}\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)>

        <math|f:\<bbb-R\>\<rightarrow\>\<bbb-R\>>
        <math|<with|color|black|\<rightsquigarrow\>>>
        <math|f<rsup|\<circ\>>:\<cal-B\>(\<bbb-R\>,\<bbb-R\>)\<rightarrow\>\<cal-B\>(\<bbb-R\>,\<bbb-R\>)>,
        <math|\<forall\><wide|x|~>\<in\>x<rsup|\<circ\>>,f(<wide|x|~>)\<in\>f<rsup|\<circ\>>(x<rsup|\<circ\>>)>.
      </hidden>|<\hidden>
        <math|x<rsup|\<circ\>>=\<cal-B\>(x<rsub|c>,x<rsub|r>)={<wide|x|~>\<in\>\<bbb-R\>:\|<wide|x|~>-x<rsub|c>\|\<leqslant\>x<rsub|r>}\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)>

        <math|f:\<bbb-R\><rsup|com>\<rightarrow\>\<bbb-R\><rsup|com>>
        <math|<with|color|black|\<rightsquigarrow\>>>
        <math|f<rsup|\<circ\>>:\<cal-B\>(\<bbb-D\>,\<bbb-D\>)\<rightarrow\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)>,
        <math|\<forall\><wide|x|~>\<in\>x<rsup|\<circ\>>,f(<wide|x|~>)\<in\>f<rsup|\<circ\>>(x<rsup|\<circ\>>)>.

        <math|x\<in\>\<bbb-R\><rsup|com>>
        <math|<with|color|black|\<leftrightsquigarrow\>>>
        <math|\<exists\><wide|x|\<check\>>:n\<in\>\<bbb-N\>\<longmapstolim\><rsup|comp><wide|x|\<check\>><rsub|n>\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)>,
        <math|x\<in\><wide|x|\<check\>><rsub|n>>,
        <math|lim<rsub|n\<rightarrow\>\<infty\>>(<wide|x|\<check\>><rsub|n>)<rsub|r>=0><vspace|0.5fn>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Numerical level>

      <math|x\<in\>\<bbb-D\><rsub|p,e>={\<um\>2<rsup|p-1>,\<ldots\>,0,\<ldots\>,2<rsup|p-1>-1}*2<rsup|{\<um\>2<rsup|e-1>,\<ldots\>,0,\<ldots\>,2<rsup|e-1>-1}>>

      <math|\<bbb-D\><rsub|52,12>> <math|<with|color|black|\<leftrightsquigarrow\>>>
      ``double precision IEEE 784 number''

      <math|<with|color|dark green|\<lightning\>>> Correct
      rounding<vspace|0.5fn>
    </hidden*>|<\hidden*>
      <strong|Arithmetic level>

      <math|x\<in\>\<bbb-Z\>> or <math|x\<in\>{\<um\>2<rsup|p-1>,\<ldots\>,0,\<ldots\>,2<rsup|p-1>-1}>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Matrix multiplication>

    <unroll|<\shown>
      <strong|Mathematical level>

      <switch|<\shown>
        <math|M,N\<in\>(\<bbb-R\><rsup|com>)<rsup|n\<times\>n>>, <math|M*N>?
      </shown>|<\hidden>
        <math|M,N\<in\>(\<bbb-R\><rsup|com>)<rsup|n\<times\>n>\<cong\>(\<bbb-R\><rsup|n\<times\>n>)<rsup|com>>

        <math|M\<in\>(\<bbb-R\><rsup|com>)<rsup|n\<times\>n>>
        <math|<with|color|black|\<leftrightsquigarrow\>>>
        <math|\<exists\><wide|M|\<check\>>:\<varepsilon\>\<in\>\<bbb-D\><rsup|\<gtr\>>\<longmapstolim\><rsup|comp><wide|M|~>\<in\>\<bbb-D\><rsup|n\<times\>n>>,
        <math|\|<wide|M|~>-M\|\<leqslant\>\<varepsilon\>>, sup-norm on
        <math|\<bbb-R\><rsup|n\<times\>n>>
      </hidden>|<\hidden>
        <math|M,N\<in\>(\<bbb-R\><rsup|com>)<rsup|n\<times\>n>\<cong\>(\<bbb-R\><rsup|n\<times\>n>)<rsup|com>>

        <math|M\<in\>(\<bbb-R\><rsup|com>)<rsup|n\<times\>n>>
        <math|<with|color|black|\<leftrightsquigarrow\>>>
        <math|\<exists\><wide|M|\<check\>>:n\<in\>\<bbb-N\>\<longmapstolim\><rsup|comp><wide|M|\<check\>><rsub|n>\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)<rsup|n\<times\>n><vspace|0.5fn>>
      </hidden>>
    </shown>|<\hidden*>
      <strong|Reliable level>

      <switch|<\shown>
        <math|M<rsup|\<circ\>>,N<rsup|\<circ\>>\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)<rsup|n\<times\>n>>,
        <math|M*N>?
      </shown>|<\hidden>
        <math|M<rsup|\<circ\>>,N<rsup|\<circ\>>\<in\>\<cal-B\>(\<bbb-D\>,\<bbb-D\>)<rsup|n\<times\>n>\<cong\>\<cal-B\>(\<bbb-D\><rsup|n\<times\>n>,\<bbb-D\><rsup|n\<times\>n>)\<cong\>\<cal-B\>(\<bbb-D\><rsup|n\<times\>n>,\<bbb-D\>)><vspace|0.5fn>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Numerical level>

      <math|M,N\<in\>\<bbb-D\><rsub|p,e><rsup|n\<times\>n>>, <math|M*N>?

      <\itemize>
        <item><math|\<bbb-D\><rsub|p,e>=\<bbb-D\><rsub|52,12>>
        <math|<with|color|black|\<rightsquigarrow\>>> Blas

        <item><math|p\<gtr\>52>, <math|\<bbb-D\><rsup|n\<times\>n>\<cong\>\<bbb-Z\><rsup|n\<times\>n>*2<rsup|\<bbb-Z\>>><vspace|0.5fn>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Arithmetic level>

      <math|M,N\<in\>\<bbb-Z\><rsup|n\<times\>n>>, <math|M*N>

      FFT or Chinese remaindering depending on <math|<frac|n|p>>, with
      <math|p> = bit precision
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Intervals versus balls>

    \;

    <\pine>
      <tabular*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|2|2|cell-hpart|1>|<cwith|1|-1|3|3|cell-hpart|1>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|2|cell-lborder|1ln>|<cwith|1|-1|3|3|cell-lborder|1ln>|<cwith|1|1|1|-1|cell-bborder|1ln>|<cwith|2|2|1|-1|cell-bborder|1ln>|<cwith|4|4|1|-1|cell-bborder|1ln>|<cwith|1|-1|1|-1|cell-bsep|1spc>|<cwith|1|-1|1|-1|cell-tsep|1spc>|<cwith|6|6|1|-1|cell-bborder|1ln>|<cwith|7|7|2|2|cell-hpart|1>|<cwith|7|7|3|3|cell-hpart|1>|<cwith|7|7|1|1|cell-halign|l>|<cwith|7|7|2|2|cell-lborder|1ln>|<cwith|7|7|3|3|cell-lborder|1ln>|<cwith|7|7|1|3|cell-bborder|1ln>|<cwith|7|7|1|3|cell-bsep|1spc>|<cwith|7|7|1|3|cell-tsep|1spc>|<cwith|8|8|1|-1|cell-bborder|1ln>|<cwith|9|9|1|-1|cell-hyphen|t>|<cwith|9|9|1|-1|cell-bborder|1ln>|<cwith|10|10|3|3|cell-hyphen|t>|<table|<row|<cell|>|<cell|<strong|Intervals>>|<cell|<strong|Balls>>>|<row|<cell|Representation>|<cell|<math|[2,\<infty\>]>>|<cell|<math|{z\<in\>\<bbb-C\>:\|z\|\<leqslant\>1}>>>|<row|<cell|Hardware
      support>|<cell|IEEE 754>|<cell|not yet>>|<row|<cell|>|<cell|<math|x+<rsup|\<downarrow\>>y=\<um\>((\<um\>x)+<rsup|\<uparrow\>>(\<um\>y))>>|<cell|<math|\<Delta\>(y)=(\|y\|+<rsup|\<uparrow\>>2<rsup|\<um\>2<rsup|e-1>>)*\<cdot\><rsup|\<uparrow\>>2<rsup|\<um\>p>>>>|<row|<cell|Efficiency>|<cell|end-points
      at full precision>|<cell|radius at single
      precision>>|<row|<cell|>|<cell|multiplication
      <math|<op|\<rightsquigarrow\>>> branching>|<cell|completely
      vectorial>>|<row|<cell|Standardization>|<cell|correct
      rounding>|<cell|explicit formulas for
      operations>>|<row|<cell|Standardness>|<cell|computer
      science>|<cell|mathematics>>|<row|<\cell>
        Recommendation
      </cell>|<\cell>
        <\with|par-mode|center>
          algorithms that require<new-line>subdivision of space
        </with>
      </cell>|<\cell>
        approximation of numbers
      </cell>>|<row|<cell|Predicates>|<cell|values in
      <math|\<cal-I\><rsub|{0,1}>>>|<\cell>
        <\with|par-mode|center>
          values in <math|{0,1}>

          also, <math|<op|=>:(\<bbb-R\><rsup|com>)<rsup|2>\<rightarrow\>{0,1}<rsup|rcom>>
        </with>
      </cell>>>>><htab|5mm>
    </pine>
  </hidden>|<\hidden>
    <tit|The wrapping effect and the radius type>

    <\big-figure*|<with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1.33334cm|<tuple|0.180019gw|0.099947gh>>|gr-geometry|<tuple|geometry|0.273362par|0.260014par|bottom>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-fill-color|default|gr-text-at-valign|center|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|arrow-length|10ln|arrow-height|6ln|gr-arrow-end|\<gtr\>|magnify|1.33333333333333|<graphics||<with|fill-color|pastel
    orange|magnify|0.562499296875879|<cline|<point|0.8|0.8>|<point|1.2|0.8>|<point|1.2|1.2>|<point|0.8|1.2>>>|<with|fill-color|pastel
    yellow|magnify|0.750001875004688|<cline|<point|-0.4|1.6>|<point|0.4|1.6>|<point|0.4|2.4>|<point|-0.4|2.4>>>|<with|fill-color|pastel
    orange|magnify|0.750001875004688|<cline|<point|0|1.6>|<point|0.4|2.0>|<point|0.0|2.4>|<point|-0.4|2.0>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|0.535713329083341|<line|<point|0|-0.3>|<point|0.0|3.5>>>|<point|1|1>|<point|0|2>|<with|text-at-valign|center|<text-at|<math|z>|<point|1.4|1>>>|<with|text-at-valign|center|<text-at|<math|z<rsup|2>>|<point|0.6|2>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|0.750001875004688|<line|<point|-0.5|0>|<point|2.5|0.0>>>>><space|4em><with|gr-mode|<tuple|edit|line>|gr-frame|<tuple|scale|1.33334cm|<tuple|0.180019gw|0.0899493gh>>|gr-geometry|<tuple|geometry|0.273362par|0.260014par|bottom>|gr-grid|<tuple|cartesian|<point|0|0>|1>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|10|none>>|gr-edit-grid|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-fill-color|default|gr-text-at-valign|center|gr-grid-aspect-props|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|gr-grid-aspect|<tuple|<tuple|axes|#808080>|<tuple|1|#c0c0c0>|<tuple|10|#e0e0ff>>|arrow-length|10ln|arrow-height|6ln|gr-arrow-end|\<gtr\>|magnify|1.33333333333333|<graphics||<with|fill-color|pastel
    orange|magnify|0.750001875004688|<carc|<point|1|0.8>|<point|1.2|1.0>|<point|1.0|1.2>>>|<point|1|1>|<with|fill-color|pastel
    orange|magnify|0.750001875004688|<carc|<point|0.2|1.8>|<point|0.2|2.2>|<point|-0.2|2.2>>>|<point|0|2>|<with|text-at-valign|center|<text-at|<math|z>|<point|1.4|1>>>|<with|text-at-valign|center|<text-at|<math|z<rsup|2>>|<point|0.6|2>>>|<with|fill-color|pastel
    orange|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|0.750001875004688|<line|<point|-0.5|0>|<point|2.5|0.0>>>|<with|arrow-length|10ln|arrow-height|6ln|arrow-end|\<gtr\>|magnify|0.535713329083341|<line|<point|0|-0.3>|<point|0.0|3.5>>>>>>
      <label|wrap-fig>Illustration of the computation of <math|z<rsup|2>>
      using interval and ball arithmetic, for <math|z=1+\<mathi\>>.
    </big-figure*>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          <strong|Intervals>
        <|folded>
          <\input>
            <mmx-prompt|1>
          <|input>
            use "analyziz";
          </input>

          <\input>
            <mmx-prompt|2>
          <|input>
            z1 == complex (polynomial ball (1.0), polynomial ball (1.0))
          </input>

          <\input>
            <mmx-prompt|3>
          <|input>
            pow (u, n) == if n=1 then u else u * pow (u, n-1);
          </input>

          <\input>
            <mmx-prompt|4>
          <|input>
            [ pow (z1, 8*i) \|\| i in 1 to 10 ]
          </input>

          <\input>
            <mmx-prompt|5>
          <|input>
            \;
          </input>
        </folded>

        <\folded>
          <strong|Balls>
        <|folded>
          <\input>
            <mmx-prompt|5>
          <|input>
            z2 == ball complex (1.0, 1.0)
          </input>

          <\input>
            <mmx-prompt|6>
          <|input>
            [ pow (z2, 8*i) \|\| i in 1 to 10 ]
          </input>

          <\input>
            <mmx-prompt|7>
          <|input>
            \;
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Reducing the wrapping effect>

    <unroll|<\shown>
      <strong|Use divide and conquer algorithms>

      <abbr|I.e.> keep depth of the arithmetic circuit small

      <\eqnarray*>
        <tformat|<table|<row|<cell|z<rsup|n>>|<cell|=>|<cell|z<rsup|<left|lfloor|1><frac|n|2><right|rfloor|1>>*z<rsup|<left|lceil|1><frac|n|2><right|rceil|1>>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <switch|<\shown>
        <\small>
          <\session|mathemagix|default>
            <\input>
              <mmx-prompt|7>
            <|input>
              binpow (u, n) ==

              \ \ if n = 1 then u else binpow (u, n div 2) * binpow (u, (n+1)
              div 2);
            </input>

            <\input>
              <mmx-prompt|8>
            <|input>
              [ pow (z1, 8*i), binpow (z1, 8*i) \|\| i in 1 to 10 ]
            </input>

            <\input>
              <mmx-prompt|9>
            <|input>
              \;
            </input>
          </session>
        </small>
      </shown>|<\hidden>
        <strong|Changes of coordinates>

        Enclose vectors by products <math|M*V<rsup|\<leftrightmap\>>>,
        <math|M\<in\>\<bbb-D\><rsup|n\<times\>n>>,
        <math|V\<in\>\<cal-I\><rsub|\<bbb-D\>><rsup|n>>

        Useful for differential equations, <abbr|e.g.>

        <\eqnarray*>
          <tformat|<table|<row|<cell|f<rprime|'>=<matrix|<tformat|<table|<row|<cell|cos<rprime|'>>>|<row|<cell|sin<rprime|'>>>>>>>|<cell|=>|<cell|<matrix|<tformat|<table|<row|<cell|0>|<cell|\<um\>1>>|<row|<cell|1>|<cell|0>>>>>*<matrix|<tformat|<table|<row|<cell|cos>>|<row|<cell|sin>>>>>=A*f>>>>
        </eqnarray*>

        Works because rounding errors all accumulate at the same side:

        <\eqnarray*>
          <tformat|<cwith|2|2|3|3|cell-valign|c>|<table|<row|<cell|f(t<rsub|0>)>|<cell|=>|<cell|M<rsub|0>*V<rsub|0><rsup|\<leftrightmap\>>>>|<row|<cell|f(t<rsub|1>)>|<cell|=>|<cell|\<Delta\><rsub|t<rsub|0>,t<rsub|1>>*(M<rsub|0>*V<rsub|0><rsup|\<leftrightmap\>>)=<wide|\<Delta\><rsub|t<rsub|0>,t<rsub|1>>*M<rsub|0>|~>*(V<rsub|0><rsup|\<leftrightmap\>>+\<varepsilon\><rsup|\<leftrightmap\>>)>>>>
        </eqnarray*>

        Not suited for general purpose complex ball arithmetic, because of
        sums
      </hidden>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Quality and condition number>

    <unroll|<\shown>
      <strong|Condition number>

      <\eqnarray*>
        <tformat|<table|<row|<cell|f:\<bbb-R\><rsup|n>>|<cell|\<rightarrow\>>|<cell|\<bbb-R\><rsup|m>>>|<row|<cell|\<kappa\><rsub|f>(x)>|<cell|=>|<cell|lim<rsub|\<varepsilon\>\<rightarrow\>0>sup<rsub|\<\|\|\>\<delta\>\<\|\|\>=\<varepsilon\>><left|.><frac|\<\|\|\>f(x+\<delta\>)-f(x)\<\|\|\>|\<\|\|\>f(x)\<\|\|\>><mid|/><frac|\<\|\|\>\<delta\>\<\|\|\>|\<\|\|\>x\<\|\|\>><right|.>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      \;

      <strong|Linear algebra>

      <\eqnarray*>
        <tformat|<table|<row|<cell|\<kappa\>(M)>|<cell|=>|<cell|\<kappa\><rsub|M<rsup|\<um\>1>\<cdot\>>(x)>>|<row|<cell|>|<cell|=>|<cell|\<\|\|\>M\<\|\|\>*\<\|\|\>M<rsup|\<um\>1>\<\|\|\>.<htab|5mm><with|color|grey|operator
        norms>>>>>
      </eqnarray*>
    </hidden*>|<\hidden*>
      \;

      <strong|Integration of a dynamical system>

      <switch|<\shown>
        <\eqnarray*>
          <tformat|<table|<row|<cell|f<rprime|'>>|<cell|=>|<cell|\<Phi\>(f)>>|<row|<cell|\<kappa\>(\<Phi\>,f(0),0,t)>|<cell|=>|<cell|max<rsub|0\<leqslant\>u\<leqslant\>t>\<kappa\>(\<Delta\><rsub|0,u>(f(0))>>>>
        </eqnarray*>
      </shown>|<\hidden>
        <\eqnarray*>
          <tformat|<table|<row|<cell|f<rprime|'>>|<cell|=>|<cell|\<Phi\>(f)>>|<row|<cell|\<kappa\>(\<Phi\>,f(0),0,t)>|<cell|=>|<cell|max<rsub|0\<leqslant\>u\<leqslant\>v\<leqslant\>t>\<kappa\>(\<Delta\><rsub|u,v>(f(u))>>>>
        </eqnarray*>
      </hidden>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Efficient ball arithmetic>

    <unroll|<\shown>
      <strong|Real numbers>

      <\eqnarray*>
        <tformat|<table|<row|<cell|\<cal-B\>(x<rsub|c>,x<rsub|r>)\<cdot\>\<cal-B\>(y<rsub|c>,y<rsub|r>)>|<cell|=>|<cell|\<cal-B\>(x<rsub|c><with|color|dark
        green|\<cdot\><rsup|\<updownarrow\>>>y<rsub|c>,(\|x<rsub|c>\|+<rsup|\<uparrow\>>x<rsub|r>)<with|color|dark
        blue|\<cdot\><rsup|\<uparrow\>>>y<rsub|r>+<rsup|\<uparrow\>>x<rsub|r><with|color|dark
        blue|\<cdot\><rsup|\<uparrow\>>>\|y<rsub|c>\|+<rsup|\<uparrow\>>\<Delta\>(x<rsub|c>\<cdot\><rsup|\<updownarrow\>>y<rsub|c>))>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <strong|Matrices>

      <switch|<\shown>
        <\eqnarray*>
          <tformat|<table|<row|<cell|M<rsup|\<circ\>>*N<rsup|\<circ\>>>|<cell|=>|<cell|\<cal-B\>(M<rsub|c>*N<rsub|c>,(\|M<rsub|c>\|+M<rsub|r>)*N<rsub|r>+M<rsub|r>*\|N<rsub|c>\|+\<Delta\>)>>>>
        </eqnarray*>
      </shown>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<cell|M<rsup|\<circ\>>*N<rsup|\<circ\>>>|<cell|=>|<cell|\<cal-B\>(M<rsub|c>*N<rsub|c>,[(\<\|\|\>M<rsub|c>\<\|\|\>+\<\|\|\>M<rsub|r>\<\|\|\>)*\<\|\|\>N<rsub|r>\<\|\|\>+\<\|\|\>M<rsub|r>\<\|\|\>*\<\|\|\>N<rsub|c>\<\|\|\>+\<Delta\>]*\<Omega\>)>>|<row|<cell|\<Omega\>>|<cell|=>|<cell|<with|math-display|false|<matrix|<tformat|<table|<row|<cell|\<cal-B\>(0,1)>|<cell|\<cdots\>>|<cell|\<cal-B\>(0,1)>>|<row|<cell|\<vdots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|\<cal-B\>(0,1)>|<cell|\<cdots\>>|<cell|\<cal-B\>(0,1)>>>>>>>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<cell|(M<rsup|\<circ\>>*N<rsup|\<circ\>>)<rsub|i\<nonesep\>j>>|<cell|=>|<cell|\<cal-B\>((M<rsub|c>*N<rsub|c>)<rsub|i\<nonesep\>j>,(\<\|\|\>M<rsub|c>\<\|\|\>+\<\|\|\>M<rsub|r>\<\|\|\>)*\<\|\|\>N<rsub|r>\<\|\|\>+\<\|\|\>M<rsub|r>\<\|\|\>*\<\|\|\>N<rsub|c>\<\|\|\>+\<Delta\>)>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|3|3|cell-bsep|1spc>|<table|<row|<cell|(M<rsup|\<circ\>>*N<rsup|\<circ\>>)<rsub|i\<nonesep\>j>>|<cell|=>|<cell|\<cal-B\>((M<rsub|c>*N<rsub|c>)<rsub|i\<nonesep\>j>,(\<\|\|\>(M<rsub|c>)<rsub|i\<cdot\>>\<\|\|\>+\<\|\|\>(M<rsub|r>)<rsub|i\<cdot\>>\<\|\|\>)*\<\|\|\>(N<rsub|r>)<rsub|\<cdot\>j>\<\|\|\>+\<\|\|\>(M<rsub|r>)<rsub|i\<cdot\>>\<\|\|\>*\<\|\|\>(N<rsub|c>)<rsub|\<cdot\>j>\<\|\|\>+\<Delta\>)>>>>
        </eqnarray*>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Preconditioning>

      <switch|<\shown>
        <\equation*>
          <matrix|<tformat|<cwith|1|-1|1|-1|cell-halign|l>|<table|<row|<cell|1.0000<with|color|dark
          blue|e10>>|<cell|2.1000<with|color|dark
          blue|e5>>|<cell|6.3333<with|color|dark
          blue|e8>>>|<row|<cell|2.1111<with|color|dark
          blue|e16>>|<cell|1.1428<with|color|dark
          blue|e10>>|<cell|3.9876<with|color|dark
          blue|e12>>>|<row|<cell|2.2187<with|color|dark
          blue|e7>>|<cell|1.2134<with|color|dark
          blue|e2>>|<cell|9.8765<with|color|dark
          blue|e5>>>>>><matrix|<tformat|<table|<row|<cell|1.2222<with|color|dark
          blue|e10>>|<cell|4.3245<with|color|dark
          blue|e6>>>|<row|<cell|1.2345<with|color|dark
          blue|e13>>|<cell|2.3456<with|color|dark
          blue|e8>>>|<row|<cell|2.4325<with|color|dark
          blue|e12>>|<cell|5.3235<with|color|dark blue|e8>>>>>>
        </equation*>
      </shown>|<\hidden>
        <\equation*>
          <matrix|<tformat|<cwith|1|-1|1|-1|cell-halign|l>|<table|<row|<cell|1.0000<with|color|dark
          blue|e10>>|<cell|2.1000<with|color|dark
          blue|e9>>|<cell|6.3333<with|color|dark
          blue|e10>>>|<row|<cell|2.1111<with|color|dark
          blue|e16>>|<cell|1.1428<with|color|dark
          blue|e13>>|<cell|3.9876<with|color|dark
          blue|e14>>>|<row|<cell|2.2187<with|color|dark
          blue|e7>>|<cell|1.2134<with|color|dark
          blue|e6>>|<cell|9.8765<with|color|dark
          blue|e7>>>>>><matrix|<tformat|<cwith|1|-1|1|-1|cell-halign|l>|<table|<row|<cell|1.2222<with|color|dark
          blue|e10>>|<cell|4.3245<with|color|dark
          blue|e6>>>|<row|<cell|1.2345<with|color|dark
          blue|e9>>|<cell|2.3456<with|color|dark
          blue|e4>>>|<row|<cell|2.4325<with|color|dark
          blue|e10>>|<cell|5.3235<with|color|dark blue|e6>>>>>>
        </equation*>
      </hidden>>
    </hidden*>|<\hidden*>
      <strong|Subdivision>

      <switch|<\shown>
        <\equation*>
          <small|<matrix|<tformat|<table|<row|<cell|a<rsub|00>>|<cell|a<rsub|01>>|<cell|a<rsub|02>>|<cell|a<rsub|03>>|<cell|a<rsub|04>>|<cell|a<rsub|05>>>|<row|<cell|a<rsub|10>>|<cell|a<rsub|11>>|<cell|a<rsub|12>>|<cell|a<rsub|13>>|<cell|a<rsub|14>>|<cell|a<rsub|15>>>|<row|<cell|a<rsub|20>>|<cell|a<rsub|21>>|<cell|a<rsub|22>>|<cell|a<rsub|23>>|<cell|a<rsub|24>>|<cell|a<rsub|25>>>|<row|<cell|a<rsub|30>>|<cell|a<rsub|31>>|<cell|a<rsub|32>>|<cell|a<rsub|33>>|<cell|a<rsub|34>>|<cell|a<rsub|35>>>|<row|<cell|a<rsub|40>>|<cell|a<rsub|41>>|<cell|a<rsub|42>>|<cell|a<rsub|43>>|<cell|a<rsub|44>>|<cell|a<rsub|45>>>|<row|<cell|a<rsub|50>>|<cell|a<rsub|51>>|<cell|a<rsub|52>>|<cell|a<rsub|53>>|<cell|a<rsub|54>>|<cell|a<rsub|55>>>>>>>
        </equation*>
      </shown>|<\hidden>
        <\equation*>
          <small|<matrix|<tformat|<cwith|1|-1|3|3|cell-rborder|1ln>|<cwith|3|3|1|-1|cell-bborder|1ln>|<table|<row|<cell|a<rsub|00>>|<cell|a<rsub|01>>|<cell|a<rsub|02>>|<cell|a<rsub|03>>|<cell|a<rsub|04>>|<cell|a<rsub|05>>>|<row|<cell|a<rsub|10>>|<cell|a<rsub|11>>|<cell|a<rsub|12>>|<cell|a<rsub|13>>|<cell|a<rsub|14>>|<cell|a<rsub|15>>>|<row|<cell|a<rsub|20>>|<cell|a<rsub|21>>|<cell|a<rsub|22>>|<cell|a<rsub|23>>|<cell|a<rsub|24>>|<cell|a<rsub|25>>>|<row|<cell|a<rsub|30>>|<cell|a<rsub|31>>|<cell|a<rsub|32>>|<cell|a<rsub|33>>|<cell|a<rsub|34>>|<cell|a<rsub|35>>>|<row|<cell|a<rsub|40>>|<cell|a<rsub|41>>|<cell|a<rsub|42>>|<cell|a<rsub|43>>|<cell|a<rsub|44>>|<cell|a<rsub|45>>>|<row|<cell|a<rsub|50>>|<cell|a<rsub|51>>|<cell|a<rsub|52>>|<cell|a<rsub|53>>|<cell|a<rsub|54>>|<cell|a<rsub|55>>>>>>>
        </equation*>
      </hidden>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Hansen's method>

    <unroll|<\shown>
      <strong|Inversion of a matrix>

      <\eqnarray*>
        <tformat|<table|<row|<cell|M<rsup|\<circ\>>>|<cell|\<in\>>|<cell|\<cal-B\>(\<bbb-D\>,\<bbb-D\>)<rsup|n\<times\>n>>>|<row|<cell|N<rsub|c>>|<cell|\<assign\>>|<cell|fl<rsub|p>(<with|color|dark
        green|M<rsub|c><rsup|\<um\>1>>)>>|<row|<cell|E<rsup|\<circ\>>>|<cell|\<assign\>>|<cell|1-<with|color|dark
        green|M<rsup|\<circ\>>*N<rsub|c>>>>|<row|<cell|(1-E<rsup|\<circ\>>)<rsup|\<um\>1>>|<cell|\<assign\>>|<cell|1+E<rsup|\<circ\>>+<frac|\<\|\|\>E<rsup|\<circ\>>\<\|\|\><rsup|2>|1-\<\|\|\>E<rsup|\<circ\>>\<\|\|\>>*<small|<matrix|<tformat|<table|<row|<cell|\<cal-B\>(0,1)>|<cell|\<cdots\>>|<cell|\<cal-B\>(0,1)>>|<row|<cell|\<vdots\>>|<cell|>|<cell|\<vdots\>>>|<row|<cell|\<cal-B\>(0,1)>|<cell|\<cdots\>>|<cell|\<cal-B\>(0,1)>>>>>>>>|<row|<cell|(M<rsup|\<circ\>>)<rsup|\<um\>1>>|<cell|\<assign\>>|<cell|N<rsub|c>*(1-E<rsup|\<circ\>>)<rsup|\<um\>1>>>>>
      </eqnarray*>
    </shown>|<\hidden*>
      <strong|Large <math|p>>

      <\eqnarray*>
        <tformat|<table|<row|<cell|\<\|\|\>E<rsup|\<circ\>>\<\|\|\>>|<cell|\<approx\>>|<cell|\<kappa\>(M)*2<rsup|\<um\>p>>>>>
      </eqnarray*>
    </hidden*>|<\hidden*>
      <strong|Increased quality>

      <switch|<\shown>
        <\eqnarray*>
          <tformat|<table|<row|<cell|M>|<cell|=>|<cell|<matrix|<tformat|<table|<row|<cell|1>|<cell|K>|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|1>|<cell|K>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|\<ddots\>>|<cell|\<ddots\>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>|<cell|1>|<cell|K>>|<row|<cell|>|<cell|>|<cell|>|<cell|>|<cell|1>>>>>>>>>
        </eqnarray*>
      </shown>|<\hidden>
        <\eqnarray*>
          <tformat|<table|<row|<cell|(1-E<rsup|\<circ\>>)<rsup|\<um\>1>>|<cell|\<assign\>>|<cell|(1+E<rsup|\<circ\>>)*(1+(E<rsup|\<circ\>>)<rsup|2>)*\<cdots\>*(1+(E<rsup|\<circ\>>)<rsup|2<rsup|p-1>>)+O(\<\|\|\>E<rsup|\<circ\>>\<\|\|\><rsup|2<rsup|p>>)>>>>
        </eqnarray*>
      </hidden>>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Efficient arithmetic in <math|\<cal-B\>(\<bbb-D\>,\<bbb-D\>)[[z]]<rsup|com>>>

    <\small>
      <\session|mathemagix|default>
        <\folded>
          <strong|Floating point coefficients at precision <math|p=128>>
        <|folded>
          <\input>
            <mmx-prompt|110>
          <|input>
            use "analyziz";
          </input>

          <\input>
            <mmx-prompt|111>
          <|input>
            bit_precision := 128;
          </input>

          <\input>
            <mmx-prompt|112>
          <|input>
            time_mode? := true;
          </input>

          <\input>
            <mmx-prompt|113>
          <|input>
            z1 == series (0.0, 1.0);
          </input>

          <\input>
            <mmx-prompt|114>
          <|input>
            B1 == exp (exp z1 - 1)
          </input>

          <\input>
            <mmx-prompt|115>
          <|input>
            B1[5000]
          </input>
        </folded>

        <\folded>
          <strong|Ball coefficients at precision <math|p=128>>
        <|folded>
          <\input>
            <mmx-prompt|116>
          <|input>
            z2 == series (ball 0.0, ball 1.0);
          </input>

          <\input>
            <mmx-prompt|117>
          <|input>
            B2 == exp (exp z2 - 1);
          </input>

          <\input>
            <mmx-prompt|118>
          <|input>
            B2[5000]
          </input>
        </folded>

        <\folded>
          <strong|Floating point coefficients at precision <math|p=256>>
        <|folded>
          <\input>
            <mmx-prompt|119>
          <|input>
            bit_precision := 256;
          </input>

          <\input>
            <mmx-prompt|120>
          <|input>
            z3 == series (0.0, 1.0);
          </input>

          <\input>
            <mmx-prompt|121>
          <|input>
            B3 == exp (exp z3 - 1);
          </input>

          <\input>
            <mmx-prompt|122>
          <|input>
            B3[5000]
          </input>
        </folded>

        <\folded>
          <strong|Ball coefficients at precision <math|p=256>>
        <|folded>
          <\input>
            <mmx-prompt|123>
          <|input>
            z4 == series (ball 0.0, ball 1.0);
          </input>

          <\input>
            <mmx-prompt|124>
          <|input>
            B4 == exp (exp z4 - 1);
          </input>

          <\input>
            <mmx-prompt|125>
          <|input>
            B4[5000]
          </input>
        </folded>
      </session>
    </small>
  </hidden>|<\hidden>
    <tit|Conclusion>

    \;

    <\itemize>
      <item>Tradeoff between efficiency and quality; condition number.

      <item>At high precision, certification should be of neglectible cost.

      <item>High <with|color|dark brown|p>recision <math|\<leftrightarrow\>>
      Algebraic complex<with|color|dark brown|i>ty

      Low <with|color|dark brown|p>recision <math|\<leftrightarrow\>>
      Geometry, condition numb<with|color|dark brown|e>r

      \;

      \;

      \;

      <action|Thank you !|(system "qtplay Swine.m4a &")>
    </itemize>
  </hidden>|<\hidden>
    <\granite>
      \;

      \;

      \;

      \;

      <htab|5mm><with|magnification|3|<anim-compose|<anim-constant|<strong|Starring...>|3sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Music>>>|<row|<cell|>>|<row|<cell|Electric
      swine orchestra>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Lead
      singer>>>|<row|<cell|>>|<row|<cell|Alexandre
      Sdoglendieck>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Choral>>>|<row|<cell|>>|<row|<cell|Gunal
      Safey el Din>>|<row|<cell|Mohab Renault>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Despite>>>|<row|<cell|>>|<row|<cell|Imperial
      Japanese Navy>>|<row|<cell|Imperial Japanese Kamikase
      league>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Branlottage
      des pendules>>>|<row|<cell|>>|<row|<cell|Michel
      <math|\<cal-O\>>>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Branlottage
      des pendules>>>|<row|<cell|>>|<row|<cell|Michel
      <math|\<cal-O\>>>>|<row|<cell|<small|du calme dans la
      salle...>>>>>>|5sec>|<anim-constant|<tabular*|<tformat|<table|<row|<cell|<strong|Branlottage
      des pendules>>>|<row|<cell|>>|<row|<cell|Michel
      <math|\<cal-O\>>>>|<row|<cell|<small|et sa bande de branculeurs
      enpips>>>>>>|5sec>|<tabular*|<tformat|<cwith|1|1|1|1|cell-bsep|0.25em>|<table|<row|<cell|<with|magnification|8|<larger|<strong|<with|color|magenta|M><with|color|pink|a><with|color|magenta|G><with|color|pink|i><with|color|magenta|X>>>>>>|<row|<cell|<small|International
      productions unlimited>>>>>>>><htab|5mm>

      \;

      \;

      \;

      \;

      \;

      \;

      <htab|5mm>
    </granite>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-screen-bot|5mm>
    <associate|page-screen-top|5mm>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|wrap-fig|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
  </collection>
</references>

<\auxiliary>
  <\collection>
    <\associate|figure>
      <\tuple|normal>
        <label|wrap-fig>Illustration of the computation of
        <with|color|<quote|dark red>|<with|mode|<quote|math>|z<rsup|2>>>
        using interval and ball arithmetic, for <with|color|<quote|dark
        red>|<with|mode|<quote|math>|z=1+\<mathi\>>>.
      </tuple|<pageref|auto-1>>
    </associate>
  </collection>
</auxiliary>